class com.leadpipe.attentionhog.Gauge
{
   var level;
   var mask_mc;
   var speedIncrease;
   var speedDecrease;
   function Gauge(m)
   {
      this.level = 100;
      if(m != null)
      {
         this.mask_mc = m;
      }
   }
   function initMask(m)
   {
      this.mask_mc = m;
      this.draw();
   }
   function increase()
   {
      this.level += this.speedIncrease;
      if(this.level >= 100)
      {
         this.level = 100;
      }
      this.draw();
   }
   function decrease()
   {
      this.level -= this.speedDecrease;
      if(this.level <= 0)
      {
         this.level = 0;
      }
      this.draw();
   }
   function setLevel(l)
   {
      this.level = l;
      if(this.level > 100)
      {
         this.level = 100;
      }
      else if(this.level < 0)
      {
         this.level = 0;
      }
      this.draw();
   }
   function draw()
   {
      if(this.mask_mc != null)
      {
         this.mask_mc._xscale = this.level;
      }
   }
   function setSpeed(sI, sD)
   {
      this.speedIncrease = sI;
      this.speedDecrease = sD;
   }
   function getIncSpeed()
   {
      return this.speedIncrease;
   }
   function getDecSpeed()
   {
      return this.speedDecrease;
   }
   function getLevel()
   {
      return this.level;
   }
}
