class com.leadpipe.attentionhog.Ghost extends MovieClip
{
   var blurX;
   var blurY;
   var quality;
   var blurCntr;
   var isFading;
   var filter;
   static var instanceList = new Array();
   function Ghost()
   {
      super();
      com.leadpipe.attentionhog.Ghost.instanceList.push(this);
      this.blurX = 0;
      this.blurY = 0;
      this.quality = 3;
      this.blurCntr = 0;
      this.isFading = false;
   }
   function onEnterFrame()
   {
      if(this.isFading == false)
      {
         return undefined;
      }
      this.removeFromList();
      this.blurX += 0.1;
      this.blurY += 0.1;
      this.filter = new flash.filters.BlurFilter(this.blurX,this.blurY,this.quality);
      this.filters = [this.filter];
      this._alpha -= 2;
      if(this._alpha <= 0)
      {
         this.destroy();
      }
   }
   function beginFade()
   {
      this.isFading = true;
   }
   function removeFromList()
   {
      for(var _loc2_ in com.leadpipe.attentionhog.Ghost.instanceList)
      {
         if(com.leadpipe.attentionhog.Ghost.instanceList[_loc2_] == this)
         {
            com.leadpipe.attentionhog.Ghost.instanceList.splice(_loc2_,1);
            break;
         }
      }
   }
   function destroy()
   {
      if(this.isFading == false)
      {
         this.removeFromList();
      }
      this.removeMovieClip();
   }
   static function beginFadeAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Ghost.instanceList)
      {
         com.leadpipe.attentionhog.Ghost.instanceList[_loc1_].beginFade();
      }
   }
   static function destroyAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Ghost.instanceList)
      {
         com.leadpipe.attentionhog.Ghost.instanceList[_loc1_].destroy();
      }
      com.leadpipe.attentionhog.Ghost.instanceList = new Array();
   }
   static function pauseAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Ghost.instanceList)
      {
         com.leadpipe.attentionhog.Ghost.instanceList[_loc1_].pause();
      }
   }
   static function resumeAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Ghost.instanceList)
      {
         com.leadpipe.attentionhog.Ghost.instanceList[_loc1_].resume();
      }
   }
}
