class com.leadpipe.attentionhog.Person extends MovieClip
{
   var speedNormal;
   var speedFollow;
   var speed;
   var turnAwayInc;
   var turnTowardsInc;
   var turnSpeedWalk;
   var moveMode;
   var angle;
   var angleTarget;
   var angleCurr;
   var angleRandomLast;
   var body_mc;
   var distMin;
   var changeDirTime;
   var nextChangeDir;
   var dirSwitch;
   var bounds_obj;
   var startWalkingSwitch;
   var stopFollowingSwitch;
   var chime;
   var attentionTarget;
   var pieWedge_mc;
   var heart_mc;
   var heartSwing_mc;
   var gauge;
   var point;
   var playerPoint;
   var proximity;
   var ghostPoint;
   var proxPlayer;
   var proxGhost;
   var isCaptured;
   var delta_x;
   var delta_y;
   var turnInc;
   var angleDiff;
   var followMode;
   var changeAngle;
   var stage_maxX;
   var stage_maxY;
   var startPoint;
   var playerStartPoint;
   var distInit;
   var startSide;
   var isPaused;
   static var play_maxY = 380;
   static var instanceList = new Array();
   function Person()
   {
      super();
      com.leadpipe.attentionhog.Person.instanceList.push(this);
      this.speedNormal = 1;
      this.speedFollow = 1;
      this.speed = this.speedNormal;
      this.turnAwayInc = 8;
      this.turnTowardsInc = 20;
      this.turnSpeedWalk = 0.5;
      this.moveMode = "WANDER";
      this.angle = random(360);
      this.angleTarget = this.angle;
      this.angleCurr = this.angle;
      this.angleRandomLast = this.angle;
      this.body_mc = this.body_mc;
      this.body_mc._rotation = this.angle;
      this.distMin = 75;
      this.changeDirTime = getTimer();
      this.nextChangeDir = this.randomInt(500,3000);
      this.dirSwitch = 1;
      this.bounds_obj = this.body_mc.getBounds(_root);
      this.startWalkingSwitch = 0;
      this.stopFollowingSwitch = 0;
      this.chime = new Sound(this);
      this.chime.attachSound("chime1");
      this.attentionTarget = _root.player_mc;
      this.pieWedge_mc = this.createEmptyMovieClip("pieWedge_mc",this.getNextHighestDepth());
      this.pieWedge_mc._x = 0;
      this.pieWedge_mc._y = this.heart_mc._y;
      this.heartSwing_mc.stop();
      this.heartSwing_mc._alpha = 0;
      this.heart_mc.setMask(this.pieWedge_mc);
      this.gauge = new com.leadpipe.attentionhog.GaugeCircle(this.pieWedge_mc,0,0,90,14,14);
      this.gauge.setSpeed(0.1,1);
      this.gauge.setLevel(100);
   }
   function go()
   {
      if(this.moveMode == "WANDER")
      {
         this.moveWalk();
      }
      else if(this.moveMode == "PAYATTENTION")
      {
         this.payAttention();
      }
      else if(this.moveMode == "CAPTURED")
      {
         this.moveCaptured();
      }
   }
   function soundOn(s)
   {
      if(s)
      {
         this.chime.setVolume(100);
      }
      else
      {
         this.chime.setVolume(0);
      }
   }
   function checkCapture2()
   {
      if(this.moveMode == "CAPTURED")
      {
         return false;
      }
      this.point = new flash.geom.Point(this._x,this._y);
      this.playerPoint = new flash.geom.Point(_root.player_mc._x,_root.player_mc._y);
      this.proximity = flash.geom.Point.distance(this.point,this.playerPoint);
      if(this.proximity <= com.leadpipe.attentionhog.Game.instance.proxThreshold)
      {
         this.moveMode = "PAYATTENTION";
         return true;
      }
      this.moveMode = "WANDER";
      return false;
   }
   function checkCapture1ghost()
   {
      if(this.moveMode == "CAPTURED")
      {
         return false;
      }
      this.point = new flash.geom.Point(this._x,this._y);
      this.playerPoint = new flash.geom.Point(_root.player_mc._x,_root.player_mc._y);
      if(com.leadpipe.attentionhog.Ghost.instanceList.length > 0)
      {
         this.ghostPoint = new flash.geom.Point(_root.ghost_mc._x,_root.ghost_mc._y);
         this.proxPlayer = flash.geom.Point.distance(this.point,this.playerPoint);
         this.proxGhost = flash.geom.Point.distance(this.point,this.ghostPoint);
         if(this.proxPlayer < this.proxGhost)
         {
            this.proximity = this.proxPlayer;
            this.attentionTarget = _root.player_mc;
         }
         else
         {
            this.proximity = this.proxGhost;
            this.attentionTarget = _root.ghost_mc;
         }
      }
      else
      {
         this.attentionTarget = _root.player_mc;
         this.proximity = flash.geom.Point.distance(this.point,this.playerPoint);
      }
      if(this.proximity <= com.leadpipe.attentionhog.Game.instance.proxThreshold)
      {
         this.moveMode = "PAYATTENTION";
         this.isCaptured = true;
      }
      else
      {
         this.moveMode = "WANDER";
         this.isCaptured = false;
      }
      return this.isCaptured;
   }
   function sortNum(a, b)
   {
      return a[1] - b[1];
   }
   function checkCapture()
   {
      if(this.moveMode == "CAPTURED")
      {
         return false;
      }
      this.point = new flash.geom.Point(this._x,this._y);
      this.playerPoint = new flash.geom.Point(_root.player_mc._x,_root.player_mc._y);
      var _loc4_ = new Array();
      var _loc3_ = 0;
      while(_loc3_ < com.leadpipe.attentionhog.Ghost.instanceList.length)
      {
         this.ghostPoint = new flash.geom.Point(com.leadpipe.attentionhog.Ghost.instanceList[_loc3_]._x,com.leadpipe.attentionhog.Ghost.instanceList[_loc3_]._y);
         _loc4_.push(new Array(com.leadpipe.attentionhog.Ghost.instanceList[_loc3_],flash.geom.Point.distance(this.point,this.ghostPoint)));
         _loc3_ = _loc3_ + 1;
      }
      _loc4_.push(new Array(_root.player_mc,flash.geom.Point.distance(this.point,this.playerPoint)));
      _loc4_.sort(this.sortNum);
      this.attentionTarget = _loc4_[0][0];
      this.proximity = _loc4_[0][1];
      if(this.proximity <= com.leadpipe.attentionhog.Game.instance.proxThreshold)
      {
         this.moveMode = "PAYATTENTION";
         this.isCaptured = true;
      }
      else
      {
         this.moveMode = "WANDER";
         this.isCaptured = false;
      }
      return this.isCaptured;
   }
   function payAttention()
   {
      this.delta_x = this._x - this.attentionTarget._x;
      this.delta_y = this._y - this.attentionTarget._y;
      this.angle = (- Math.atan2(this.delta_x,this.delta_y)) / 0.017453292519943295;
      this.turnInc = this.turnTowardsInc;
      this.turnTowards();
      this.startWalkingSwitch = 0;
      this.gauge.decrease();
      this.heart_mc._alpha = 100;
      if(this.gauge.getLevel() <= 0)
      {
         this.chime.start(0,1);
         this.moveMode = "CAPTURED";
         this.gotoAndStop("captured");
         this.gauge.setLevel(100);
         this.heartSwing_mc._alpha = 100;
         this.heartSwing_mc.play();
         com.leadpipe.attentionhog.Game.instance.captureHeart();
      }
   }
   function getNormalizedAngles()
   {
      if(this.angle < 0)
      {
         this.angleTarget = this.angle + 360;
      }
      else
      {
         this.angleTarget = this.angle;
      }
      if(this.body_mc._rotation < 0)
      {
         this.angleCurr = this.body_mc._rotation + 360;
      }
      else
      {
         this.angleCurr = this.body_mc._rotation;
      }
   }
   function turnTowards()
   {
      this.getNormalizedAngles();
      this.angleDiff = Math.abs(this.angleTarget - this.angleCurr);
      if(this.angleDiff < this.turnInc)
      {
         this.body_mc._rotation = this.angle;
      }
      else if(this.angleTarget > this.angleCurr && this.angleDiff < 180)
      {
         this.body_mc._rotation += this.turnInc;
      }
      else if(this.angleTarget > this.angleCurr && this.angleDiff >= 180)
      {
         this.body_mc._rotation -= this.turnInc;
      }
      else if(this.angleTarget < this.angleCurr && this.angleDiff < 180)
      {
         this.body_mc._rotation -= this.turnInc;
      }
      else if(this.angleTarget < this.angleCurr && this.angleDiff >= 180)
      {
         this.body_mc._rotation += this.turnInc;
      }
   }
   function getNewAngle()
   {
      if(!this.followMode)
      {
         if(getTimer() - this.changeDirTime > this.nextChangeDir)
         {
            this.changeDir();
            this.changeDirTime = getTimer();
         }
         this.changeAngle = this.dirSwitch * this.turnSpeedWalk;
         this.angle = (this.angle + this.changeAngle) % 360;
         if(this.angle < 0)
         {
            this.angle += 360;
         }
         this.body_mc._rotation = this.angle;
         this.angleRandomLast = this.angle;
      }
   }
   function moveWalk()
   {
      this.heart_mc._alpha = 0;
      this.turnInc = this.turnAwayInc;
      this.startWalkingSwitch = this.startWalkingSwitch + 1;
      if(this.startWalkingSwitch == 1 || this.stopFollowingSwitch == 1)
      {
         this.angle = this.angleRandomLast;
      }
      this.getNormalizedAngles();
      if(this.angleTarget != this.angleCurr)
      {
         this.turnTowards();
      }
      else
      {
         this.getNewAngle();
      }
      if(this.followMode)
      {
         this.speed = this.speedFollow;
         this.delta_x = this._x - com.leadpipe.attentionhog.Player.instance._x;
         this.delta_y = this._y - com.leadpipe.attentionhog.Player.instance._y;
         this.angle = (- Math.atan2(this.delta_x,this.delta_y)) / 0.017453292519943295;
         this.stopFollowingSwitch = 0;
      }
      else
      {
         this.speed = this.speedNormal;
         this.stopFollowingSwitch = this.stopFollowingSwitch + 1;
      }
      this._y -= this.speed * Math.cos(this.angle * 0.017453292519943295);
      this._x += this.speed * Math.sin(this.angle * 0.017453292519943295);
      this.bounds_obj = this.body_mc.getBounds(_root);
      this.stage_maxX = Stage.width + (this._x - this.bounds_obj.xMin);
      this.stage_maxY = com.leadpipe.attentionhog.Person.play_maxY + (this._y - this.bounds_obj.yMin);
      if(this.bounds_obj.yMax < 30 || this.bounds_obj.yMin > com.leadpipe.attentionhog.Person.play_maxY || this.bounds_obj.xMax < 0 || this.bounds_obj.xMin > Stage.width)
      {
         this.wrapAround();
      }
   }
   function changeDir()
   {
      if(this.moveMode == "WANDER")
      {
         this.nextChangeDir = this.randomInt(1500,6000);
      }
      else
      {
         this.nextChangeDir = this.randomInt(100,500);
      }
      this.dirSwitch *= -1;
   }
   function followPlayer(f, s)
   {
      this.followMode = f;
      this.speedFollow = s;
   }
   function moveCaptured()
   {
      this.speed = 6;
      this._xscale += 2;
      this._yscale += 2;
      this._y -= this.speed;
      this.bounds_obj = this.getBounds(_root);
      this.stage_maxX = Stage.width + (this._x - this.bounds_obj.xMin);
      this.stage_maxY = com.leadpipe.attentionhog.Person.play_maxY + (this._y - this.bounds_obj.yMin);
      if(this.bounds_obj.yMax < 30 || this.bounds_obj.yMin > com.leadpipe.attentionhog.Person.play_maxY || this.bounds_obj.xMax < 0 || this.bounds_obj.xMin > Stage.width)
      {
         this.reset();
      }
   }
   function reset()
   {
      this.heartSwing_mc._alpha = 0;
      this.heartSwing_mc.gotoAndStop(1);
      this.heartSwing_mc.stop();
      this.isCaptured = false;
      this.moveMode = "WANDER";
      this.speed = this.speedNormal;
      this._xscale = 100;
      this._yscale = 100;
      this.gotoAndStop("walk");
      this.body_mc.gotoAndStop(random(this.body_mc._totalframes) + 1);
      this.startOffScreen();
   }
   function randomInt(min, max)
   {
      return Math.floor(Math.random() * (max - min + 1)) + min;
   }
   function startOnScreen()
   {
      this.startPoint = new flash.geom.Point(this.randomInt(30,com.leadpipe.attentionhog.Person.play_maxY),this.randomInt(30,com.leadpipe.attentionhog.Person.play_maxY));
      this.playerStartPoint = new flash.geom.Point(200,230);
      this.distInit = flash.geom.Point.distance(this.startPoint,this.playerStartPoint);
      while(this.distInit < this.distMin)
      {
         this.startPoint = new flash.geom.Point(this.randomInt(30,com.leadpipe.attentionhog.Person.play_maxY),this.randomInt(30,com.leadpipe.attentionhog.Person.play_maxY));
         this.distInit = flash.geom.Point.distance(this.startPoint,this.playerStartPoint);
      }
      this.setPos(this.startPoint);
   }
   function startOffScreen()
   {
      this.startSide = random(4);
      if(this.startSide == 0)
      {
         var _loc3_ = random(400);
         this.bounds_obj = this.body_mc.getBounds(_root);
         this.stage_maxX = Stage.width + (this._x - this.bounds_obj.xMin);
         this.stage_maxY = com.leadpipe.attentionhog.Person.play_maxY + (this._y - this.bounds_obj.yMin);
         this.startPoint = new flash.geom.Point(_loc3_,this._y - this.bounds_obj.yMax);
      }
      else if(this.startSide == 1)
      {
         _loc3_ = random(400);
         this.bounds_obj = this.body_mc.getBounds(_root);
         this.stage_maxX = Stage.width + (this._x - this.bounds_obj.xMin);
         this.stage_maxY = com.leadpipe.attentionhog.Person.play_maxY + (this._y - this.bounds_obj.yMin);
         this.startPoint = new flash.geom.Point(_loc3_,this.stage_maxY);
      }
      else if(this.startSide == 2)
      {
         _loc3_ = this.randomInt(30,com.leadpipe.attentionhog.Person.play_maxY);
         this.bounds_obj = this.body_mc.getBounds(_root);
         this.stage_maxX = Stage.width + (this._x - this.bounds_obj.xMin);
         this.stage_maxY = com.leadpipe.attentionhog.Person.play_maxY + (this._y - this.bounds_obj.yMin);
         this.startPoint = new flash.geom.Point(this._x - this.bounds_obj.xMax,_loc3_);
      }
      else if(this.startSide == 3)
      {
         _loc3_ = this.randomInt(30,com.leadpipe.attentionhog.Person.play_maxY);
         this.bounds_obj = this.body_mc.getBounds(_root);
         this.stage_maxX = Stage.width + (this._x - this.bounds_obj.xMin);
         this.stage_maxY = com.leadpipe.attentionhog.Person.play_maxY + (this._y - this.bounds_obj.yMin);
         this.startPoint = new flash.geom.Point(this.stage_maxX,_loc3_);
      }
      this.setPos(this.startPoint);
   }
   function setPos(sp)
   {
      this._x = sp.x;
      this._y = sp.y;
   }
   function getMoveMode()
   {
      return this.moveMode;
   }
   function wrapAround()
   {
      if(this.bounds_obj.yMax < 30)
      {
         this._y = this.stage_maxY;
      }
      if(this.bounds_obj.yMin > com.leadpipe.attentionhog.Person.play_maxY)
      {
         this._y = 30 + this._y - this.bounds_obj.yMax;
      }
      if(this.bounds_obj.xMax < 0)
      {
         this._x = this.stage_maxX;
      }
      if(this.bounds_obj.xMin > Stage.width)
      {
         this._x = 0 + this._x - this.bounds_obj.xMax;
      }
   }
   function destroy()
   {
      for(var _loc2_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         if(com.leadpipe.attentionhog.Person.instanceList[_loc2_] == this)
         {
            com.leadpipe.attentionhog.Person.instanceList.splice(_loc2_,1);
            break;
         }
      }
      this.removeMovieClip();
   }
   function pause(p)
   {
      this.isPaused = p;
   }
   function resume()
   {
   }
   static function destroyAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         com.leadpipe.attentionhog.Person.instanceList[_loc1_].destroy();
      }
      com.leadpipe.attentionhog.Person.instanceList = new Array();
   }
   static function goAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         com.leadpipe.attentionhog.Person.instanceList[_loc1_].go();
      }
   }
   static function soundOnAll(s)
   {
      for(var _loc2_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         com.leadpipe.attentionhog.Person.instanceList[_loc2_].soundOn(s);
      }
   }
   static function pauseAll(p)
   {
      for(var _loc2_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         com.leadpipe.attentionhog.Person.instanceList[_loc2_].pause(p);
      }
   }
   static function resumeAll()
   {
      for(var _loc1_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         com.leadpipe.attentionhog.Person.instanceList[_loc1_].resume();
      }
   }
   static function followPlayerAll(f, s)
   {
      for(var _loc2_ in com.leadpipe.attentionhog.Person.instanceList)
      {
         com.leadpipe.attentionhog.Person.instanceList[_loc2_].followPlayer(f,s);
      }
   }
}
